commit fc7151bbed55fc4b7fa1f3becb10ba4a75bc21db
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Thu Mar 14 14:32:41 2019 +0100

    Introduced new LightRing v1.2 module.
    Version number has been rolled back to 1.1.3, since no new functionality has been introduced with the latest commits, but just new modules and some fixes.

diff --git a/Target/Modules/PowerManagement_1-2/Boot/main.c b/Target/Modules/PowerManagement_1-2/Boot/main.c
index d1051a1..3dc092d 100644
--- a/Target/Modules/PowerManagement_1-2/Boot/main.c
+++ b/Target/Modules/PowerManagement_1-2/Boot/main.c
@@ -88,7 +88,7 @@ void blCallbackHandleShutdownRequest(void);
 
 const blCallbackTable_t cbtable __attribute__ ((section ("_callback_table"))) = {
   .magicNumber = BL_MAGIC_NUMBER,
-  .vBootloader = {BL_VERSION_ID_AMiRoBLT_Beta, BL_VERSION_MAJOR, BL_VERSION_MINOR, 0},
+  .vBootloader = {BL_VERSION_ID_AMiRoBLT_Beta, BL_VERSION_MAJOR, BL_VERSION_MINOR, 3},
   .vSSSP = {BL_VERSION_ID_SSSP, BL_SSSP_VERSION_MAJOR, BL_SSSP_VERSION_MINOR, 0},
   .vCompiler = {BL_VERSION_ID_GCC, __GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__},  // currently only GCC is supported
   .cbShutdownHibernate = blCallbackShutdownHibernate,
@@ -309,7 +309,6 @@ static void Init(void)
   GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
   GPIO_Init(GPIOA, &GPIO_InitStructure);
 #endif
-
 } /*** end of Init ***/
 
 /*
@@ -553,7 +552,7 @@ void shutdownToTransportation() {
 } /*** end of shutdownToTransportation ***/
 
 /*
- * Final shutdown of the system to enter deepseleep mode.
+ * Final shutdown of the system to enter deepsleep mode.
  */
 void shutdownToDeepsleep() {
   /* configure some criticpal GPIOs as input
@@ -612,7 +611,7 @@ void shutdownToHibernate() {
   PWR_BackupAccessCmd(ENABLE);
   RTC_WriteBackupRegister(BL_RTC_BACKUP_REG, backup.raw);
 
-  /* morse 'OK' via the LED to signal that shutodnw was successful */
+  /* morse 'OK' via the LED to signal that shutdown was successful */
   blinkOK(1);
 
   /* reset the MCU */
@@ -641,7 +640,7 @@ void shutdownAndRestart() {
   PWR_BackupAccessCmd(ENABLE);
   RTC_WriteBackupRegister(BL_RTC_BACKUP_REG, backup.raw);
 
-  /* morse 'OK' via the LED to signal that shutodnw was successful */
+  /* morse 'OK' via the LED to signal that shutdown was successful */
   blinkOK(1);
 
   /* reset the MCU */
@@ -656,7 +655,7 @@ void shutdownAndRestart() {
  */
 void configGpioForShutdown() {
   /* setup the configuration */
-  GPIO_InitTypeDef  gpio_init;
+  GPIO_InitTypeDef gpio_init;
   gpio_init.GPIO_Mode   = GPIO_Mode_IN;
   gpio_init.GPIO_Speed  = GPIO_Speed_50MHz;
   gpio_init.GPIO_OType  = GPIO_OType_PP;
@@ -1305,7 +1304,7 @@ void blCallbackShutdownTransportation(void) {
   shutdownToTransportation();
 
   return;
-} /*** end of bLCallbackTransportation ***/
+} /*** end of blCallbackTransportation ***/
 
 /*
  * Callback function that handles the system shutdown and enters deepsleep mode.
@@ -1346,7 +1345,7 @@ void blCallbackShutdownDeepsleep(void) {
   shutdownToDeepsleep();
 
   return;
-} /*** end of bLCallbackDeepsleep ***/
+} /*** end of blCallbackDeepsleep ***/
 
 /*
  * Callback function that handles the system shutdown and enters hibernate mode.
@@ -1386,7 +1385,7 @@ void blCallbackShutdownHibernate(void) {
   shutdownToHibernate();
 
   return;
-} /*** end of bLCallbackShutdownHibernate ***/
+} /*** end of blCallbackShutdownHibernate ***/
 
 /*
  * Callback function that handles the system shutdown and initializes a restart.
@@ -1398,7 +1397,7 @@ void blCallbackShutdownRestart(void) {
   RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA | RCC_AHB1Periph_GPIOB | RCC_AHB1Periph_GPIOC | RCC_AHB1Periph_GPIOD, ENABLE);
   RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
 
-  /* set/keep the SYS_SYNC and SYS_PD signal active */
+  /* set/keep the SYS_SYNC and SYS_PD signals active */
   GPIO_ResetBits(SYS_SYNC_N_GPIO, SYS_SYNC_N_PIN);
   GPIO_ResetBits(SYS_PD_N_GPIO, SYS_PD_N_PIN);
 
@@ -1431,8 +1430,7 @@ void blCallbackShutdownRestart(void) {
   shutdownAndRestart();
 
   return;
-} /*** end of bLCallbackRestart ***/
-
+} /*** end of blCallbackRestart ***/
 
 /*
  * Callback function that handles a system shutdown/restart request from another module.
@@ -1444,7 +1442,7 @@ void blCallbackHandleShutdownRequest(void) {
   RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA | RCC_AHB1Periph_GPIOB | RCC_AHB1Periph_GPIOC | RCC_AHB1Periph_GPIOD, ENABLE);
   RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
 
-  /* set/keep the SYS_SYNC and SYS_PD signal active */
+  /* set/keep the SYS_SYNC and SYS_PD signals active */
   GPIO_ResetBits(SYS_SYNC_N_GPIO, SYS_SYNC_N_PIN);
   GPIO_ResetBits(SYS_PD_N_GPIO, SYS_PD_N_PIN);
 
@@ -1461,7 +1459,7 @@ void blCallbackHandleShutdownRequest(void) {
   /* wait for all boards to be ready for shutdown */
   GPIO_SetBits(SYS_SYNC_N_GPIO, SYS_SYNC_N_PIN);
   if (GPIO_ReadOutputDataBit(SYS_REG_EN_GPIO, SYS_REG_EN_PIN) == Bit_SET) {
-    // this must skipped if the pullup voltage (VIO3.3) is not active
+    // this must be skipped if the pullup voltage (VIO3.3) is not active
     setLed(BLT_TRUE);
     waitForSignal(SYS_SYNC_N_GPIO, SYS_SYNC_N_PIN, Bit_SET);
     setLed(BLT_FALSE);
@@ -1518,5 +1516,4 @@ void blCallbackHandleShutdownRequest(void) {
   return;
 } /*** end of blCallbackHandleShutdownRequest ***/
 
-
 /*********************************** end of main.c *************************************/